﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Windows.Forms;
using System.Drawing;

namespace りすにんぐなう {
    public partial class Form1:Form {
        private MsnCommandListener msn;
        //private Anis.Twitter.Api.Methods twitter;
        HttpConnectionOAuth httpCon;
        private IniFile setting = new IniFile(Path.Combine(Application.StartupPath, "settings.ini"));
        private int interval;

        public Form1() {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e) {
            msn = new MsnCommandListener();
            msn.ReceiveMsnCommand += new MsnCommandListener.OnReceiveMsnCommandEventHandler(msn_ReceiveMsnCommand);

            this.Left = int.Parse(setting.GetValue("Bounds", "X", this.Left.ToString()));
            this.Top = int.Parse(setting.GetValue("Bounds", "Y", this.Top.ToString()));
            this.Width = int.Parse(setting.GetValue("Bounds", "Width", this.Width.ToString()));
            this.Height = int.Parse(setting.GetValue("Bounds", "Height", this.Height.ToString()));
        }

        private void Form1_Shown(object sender, EventArgs e) {
            //twitter = new Anis.Twitter.Api.Methods(setting["twitter", "user"], setting["twitter", "pass"]);
            HttpConnection.InitializeConnection(20, HttpConnection.ProxyType.IE, "", 0, "", "");
            this.httpCon = new HttpConnectionOAuth();

            string AccessToken = setting["twitter", "AccessToken"];
            string AccessTokenSecret = setting["twitter", "AccessTokenSecret"];

            if(AccessToken == "" || AccessTokenSecret == "") {
                this.httpCon.Initialize("HnUQoMv7vr24WUP9ph8KIw", "5Ca6xT2DLsS9QSVbat7nro4pMMJMYdG7RLwp0TyeU4", "", "", "");
                string requestToken = "";
                Uri uri = null;
                httpCon.AuthenticatePinFlowRequest("http://twitter.com/oauth/request_token", "http://twitter.com/oauth/authorize", ref requestToken, ref uri);
                System.Diagnostics.Process.Start(uri.ToString());
                MessageBox.Show("ブラウザが起動してTwitterのウェブサイトが表示されたらログインし、" + Environment.NewLine +
                    "「りすにんぐなうによるアクセスを許可しますか？」と質問が表示されたら「許可する」をクリックして下さい。" + Environment.NewLine +
                    "表示された暗証番号をクリップボードにコピーして下さい。" + Environment.NewLine +
                    "コピーしたらOKボタンを押して下さい。次回の起動からこの操作は不要です。", "りすにんぐなう");
                httpCon.AuthenticatePinFlow("http://twitter.com/oauth/access_token", requestToken, Clipboard.GetText());

                AccessToken = httpCon.AccessToken;
                AccessTokenSecret = httpCon.AccessTokenSecret;
                setting["twitter", "AccessToken"] = AccessToken;
                setting["twitter", "AccessTokenSecret"] = AccessTokenSecret;
            }

            httpCon.Initialize("HnUQoMv7vr24WUP9ph8KIw", "5Ca6xT2DLsS9QSVbat7nro4pMMJMYdG7RLwp0TyeU4", AccessToken, AccessTokenSecret, "");

            msn.Start();
            string str = setting["twitter", "interval"];
            this.timer1.Interval = int.Parse(setting["twitter", "interval"]) * 1000;
            this.timer1.Start();
            this.interval = this.timer1.Interval;
            this.timer2.Start();
        }

        private void msn_ReceiveMsnCommand(MsnCommandListener.ReceiveMsnCommandEventArgs e) {
            this.Invoke((MethodInvoker)delegate {
                this.textBox1.Text = setting["twitter", "template"].Replace("%0", e.Datas[0]).Replace("%1", e.Datas[1]);
                this.button1.Enabled = e.Datas[0].Trim().Length != 0 || e.Datas[1].Trim().Length != 0;
            });
        }

        private void timer1_Tick(object sender, EventArgs e) {
            this.interval = ((Timer)sender).Interval;
            if(this.button1.Enabled && !this.textBox1.Focused) {
                try {
                    button1_Click(this.button1, EventArgs.Empty);
                } catch { };
            }
        }

        private void button1_Click(object sender, EventArgs e) {
            bool err = false;

            try {
                //twitter.UpdateStatus(this.textBox1.Text);
                Dictionary<string, string> param = new Dictionary<string, string>();
                param.Add("status", this.textBox1.Text);

                string content = "";
                System.Net.HttpStatusCode statusCode = httpCon.GetContent("POST", new Uri("http://api.twitter.com/1/statuses/update.xml"), param, ref content, null);

                if(statusCode != System.Net.HttpStatusCode.OK) {
                    err = true;
                }
            } catch {
                err = true;
            }

            if(!err) {
                ((Control)sender).Enabled = false;
                if(this.timer1.Enabled) {
                    this.timer1.Stop();
                    this.timer1.Start();
                    interval = this.timer1.Interval;
                }
            }
        }

        private void textBox1_TextChanged(object sender, EventArgs e) {
            string text = ((Control)sender).Text;
            this.button1.Enabled = !string.IsNullOrEmpty(text);
            int length = 140 - text.Length;
            this.label3.Text = length.ToString();
            if(length < 0) {
                this.label3.ForeColor = Color.Red;
            } else {
                this.label3.ForeColor = Color.Black;
            }
        }

        private void timer2_Tick(object sender, EventArgs e) {
            interval -= ((Timer)sender).Interval;
            int m = (int)(interval / 60000);
            int s = (interval % 60000) / 1000;
            this.label2.Text = m.ToString() + "分" + s.ToString() + "秒";
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e) {
            setting["Bounds", "X"] = this.Left.ToString();
            setting["Bounds", "Y"] = this.Top.ToString();
            setting["Bounds", "Width"] = this.Width.ToString();
            setting["Bounds", "Height"] = this.Height.ToString();

            msn.Stop();
            msn.Dispose();
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e) {
            this.interval = this.timer1.Interval;
            this.timer1.Enabled = this.checkBox1.Checked;
            this.timer2.Enabled = this.checkBox1.Checked;
            this.label1.Visible = this.checkBox1.Checked;
            this.label2.Visible = this.checkBox1.Checked;
        }
    }
}
